<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

    use Teknisa\PED\Controllers\TeknisaCrud;
    use Doctrine\ORM\EntityManager;
    use Zeedhi\Framework\DataSource\ParameterBag;
    use Teknisa\Libs\Util\Libraries\PHPMailer;
    use Teknisa\PED\Modules\Pedidos\Services\Ped05700importacaoSolicitacaoComprasService;
    use Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\FilterCriteria;
    use Zeedhi\Framework\DTO\Response\Error;
    use Zeedhi\Framework\DTO\Response;
    use Zeedhi\Framework\DTO\Request\Row;
    use Zeedhi\Framework\DTO;

class Ped05700importacaoSolicitacaoComprasController extends TeknisaCrud {
    protected $entityManager;
    protected $environment;
    protected $Ped05700importacaoSolicitacaoComprasService;
    protected $newCode;
    
    public function __construct($crudService, $parameterBag, $entityManager,  $environment, $Ped05700importacaoSolicitacaoComprasService, $newCode){
        parent::__construct($crudService, $parameterBag);
        $this->entityManager        	= $entityManager;
        $this->environment              = $environment;
        $this->parameterBag             = $parameterBag;
        $this->Ped05700importacaoSolicitacaoComprasService = $Ped05700importacaoSolicitacaoComprasService;
        $this->newCode                  = $newCode;
    }
    
    
    public function importarSolicitacoes(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        
        $cdfilial = $this->environment->getCdFilial();
        $arrayErro = [];
        $cdsProdFator = array();
        $cdsErroItemSoli = array();    
        
        $parampedido = $this->selectParmped($cdfilial);
            
        forEach($rows as $row){
            $validaParamPed = $this->validaParamped($row,$parampedido);
            
            if($validaParamPed == []){
                $stParam = $parampedido['IDTABPRECO'];
                $erro = false;
            }else{
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Erro na Parametrização de Pedido';
                array_push($arrayErro, $erro);   
                $erro = true;
            }
            
            if($erro != true){
                $precoBase = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBase($parampedido['CDFILIAL'], $parampedido['CDCLIENTE'], $parampedido['CDVENDEDOR'], $parampedido['CDMODPGTO']);
                if(!empty($precoBase)){
                    $precoBase = $precoBase[0]['CDPRECOBASE'];
                }
                
                $paramImpPed = $this->selectParamImpPed($cdfilial);
                
                if(empty($paramImpPed)){
                    $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                    $erro['DSERRO'] = 'Erro na Parametrização de Pedido';
                    array_push($arrayErro, $erro);
                    $erro = true;
                }
                
                if($erro != true){
                    if($paramImpPed['IDIMPSCDTENTR'] == 'S'){       
                        if($row !=null){    
                            $cdfilsoli = $row['CDFILSOLI'];
                            $cdfillan = $row['CDFILLANCA'];
                            $nrsolicmp = $row['NRSOLICMP'];
                            $dtprogentr = $row['DTPROGENTR'];
                            $cdfatpreco = $row['CDFATORPRECO'];
                            if($row['DTPROGENTR'] == null){
                                $tdtprogentr = 'T';
                            }else{
                                $tdtprogentr = '';
                            }

                            $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
                            
                            if($itemSoliRelacProdSC != []){
                                // forEach($itemSoliRelacProdSC as $rowItemSoli){
                                //     array_push($cdsProdFator, $rowItemSoli);                                
                                // }
                                
                                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                $erro['DSERRO'] = 'Erro ao importar.';
                                array_push($arrayErro, $erro);
    
                                $erro = true;
                            }
                            
                            if(!$erro){
                                if($stParam == 2){
                                    $ProdFatorDtEnt = $this->Ped05700importacaoSolicitacaoComprasService->buscaProdFatorDtEnt($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $tdtprogentr, $cdfilial);
                                    if($ProdFatorDtEnt != []){
                                        // forEach($ProdFatorDtEnt as $rowProdFator){
                                        //     array_push($cdsProdFator, $rowProdFator);
                                        // }
                                        
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSERRO'] = 'Erro no Fator de Produção';
                                        array_push($arrayErro, $erro);

                                        $erro = true;
                                    }
                                }else{
                                    if($precoBase == null){
                                        
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSERRO'] = "Não possui preço base.";
                                        array_push($arrayErro, $erro);      
                                        
                                        $erro = true;
                                    }
                                    
                                    if(!$erro){
                                        $precoBaseDtEnt = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBaseDtEnt($cdfilial, $nrsolicmp, $cdfillan, $dtprogentr, $cdfilsoli, $precoBase, $parampedido['CDCLIENTE'], $parampedido['CDMODPGTO']);
                                        if($precoBaseDtEnt != []){
                                            forEach($precoBaseDtEnt as $rowPrecoBase){
                                                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                                $erro['DSERRO'] = "O produto ".$rowPrecoBase['NMPRODUTO']." não possui preço.";
                                                array_push($arrayErro, $erro);
                                            }

                                            $erro = true;
                                        }
                                        $result ='PREC_N_CAD';
                                    }
                                }
                                
                                if(!$erro){
                                    $this->Importar($row, $paramImpPed, $parampedido);
                                }
                                
                            }else{
                                $result ='SEM_PRECO';
                                return $result;
                            }
                        }
                    }else{
                        $itemSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaItemSoli($cdfilsoli, $cdfillan, $nrsolicmp, 0, 'T');
                        if($itemSoli == null){
                            array_push($cdsErroItemSoli, $row);
                        }else{
                            $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, 0, 'T', $cdfilial);
                            if($itemSoliRelacProdSC != []){
                                // forEach($itemSoliRelacProdSC as $rowItemSoli){
                                //     array_push($cdsProdFator, $rowItemSoli);                                
                                // }
                                
                                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                $erro['DSERRO'] = 'Existem produtos na solicitação de compra que não possuem preço';
                                array_push($arrayErro, $erro);
    
                                $erro = true;
                                
                            }
                            
                        }
                        
                        if(!$erro){
                            $parampedidoCdFiliSoli = $this->selectParmped($cdfilsoli);
                            if($parampedidoCdFiliSoli != []){
                                if($parampedidoCdFiliSoli['CDCLIENTE'])
                                    $stCliente = $parampedidoCdFiliSoli['CDCLIENTE'];
                                
                                if($parampedidoCdFiliSoli['CDVENDEDOR'])
                                    $stVendedor = $parampedidoCdFiliSoli['CDVENDEDOR'];
                                    
                                if($parampedidoCdFiliSoli['CDMODPGTO'])
                                    $stModPagto = $parampedidoCdFiliSoli['CDMODPGTO'];
                            }
                        }
                        
                        $stResultFunc = $this->Ped05700importacaoSolicitacaoComprasService->prodFator();
                        if($stResultFunc = 'SEM_PRECO')
                            $result ='SEM_PRECO';
                        if($stResultFunc = 'PRECO_00')
                            $result ='PRECO_00';
                        if($stResultFunc = 'OK')
                            $this->Importar($row, $paramImpPed, $parampedido);
                            
                            $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                            $erro['DSERRO'] = 'Importação Solicitada.';
                            array_push($arrayErro, $erro);
                    }
                }
            }

        }
        $dataSet = new DataSet("data", $arrayErro );
        $response->addDataSet($dataSet);                                    
                            
    }
    
    public function selectParmped($cdfilial){
        $arrayErro = [];
        
        try{
            $filter= array(
                        array("columnName" => "CDFILIAL",
                            "operator" => "=",
                            "value" => $cdfilial
                        )
                     );
            
            $dadosParamped = new DTO\Response();
            $filterCriteria = new FilterCriteria('parampedido', $filter);
            $this->crudService->find($dadosParamped, $filterCriteria);
            $parampedido = $dadosParamped->getDataSets();
            
            if(count($parampedido[0]->getRows()) == 0){
                array_push($arrayErro, 'Parametrização de pedidos não encontrada.');
                return $arrayErro;
            }else{
                $parampedido = $parampedido[0]->getRows()[0];
                return $parampedido;
            }
        }catch(\Exception $e){
            throw $e;
        }
        
    }
    
    public function selectParamImpPed($cdfilial){
        $arrayErro = [];
        
        try{
            $filter = array(
                        array("columnName" => "CDFILIAL",
                          "operator" => "=",
                          "value" => $cdfilial
                        )
                      );
            
            $dadosparamimppedido = new DTO\Response();
            $filterCriteria = new FilterCriteria('paramimppedido', $filter);
            $this->crudService->find($dadosparamimppedido, $filterCriteria);
            
            $paramimppedido = $dadosparamimppedido->getDataSets();
            
            if(isset($paramimppedido[0])){
                $paramimppedido = $paramimppedido[0]->getRows()[0];  
                return $paramimppedido;
            }else{
                return [];
            }
           
            
        }catch(\Exception $e){
            throw $e;
        }
        
    }
    
    public function validaParamped($row, $parampedido){
    
            $arrayErro = [];

            //Validações da parampedido
            if ($parampedido == null){
                $stParam = 1;
            }else{
                $stParam = $parampedido['IDTABPRECO'];
            }
                
            if ($parampedido['IDOBRTPOPPED'] == 'S' && $parampedido['CDTIPOOPER'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Tipo de operação padrão não cadastrado';
                array_push($arrayErro, $erro);
            }
            
            if ($parampedido['CDCLIENTE'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Cliente padrão não cadastrado';
                array_push($arrayErro, $erro);
            }
            
            if ($parampedido['CDVENDEDOR'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Vendedor padrão não cadastrado';
                array_push($arrayErro, $erro);
            }
            
            if ($parampedido['CDMODPGTO'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Modalidade de pagamento padrão não cadastrado';
                array_push($arrayErro, $erro);
            }   
            
            return $arrayErro;
    }
    
    public function prodFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator, $stParam, $stCliente, $stVendedor, $stModPagto, $cdsProdFator){
        $stResult;
        $stVerifPreco;
        
        if($stParam = 2){
            $prodFator = $this->Ped05700importacaoSolicitacaoComprasService->buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator);
            if($prodFator != null){
                forEach($prodFator as $rowProdFator){
                    array_push($cdsProdFator, $rowProdFator);                                
                }
                $stVerifPreco = 'NAO_OK';
            }else{
                $stVerifPreco = 'OK';
            }
        }else{
            $stResult = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBase($cdfilial, $stCliente, $stVendedor, $stModPagto);
            if($stResult == null){
                $stResult = 'SEM_PRECO';
            }
            
            if($stResult == 'SEM_PRECO'){
                $stVerifPreco = 'OK';
                $selectPrecoBase = $this->Ped05700importacaoSolicitacaoComprasService->selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult);
                if($selectPrecoBase == null){
                    $stVerifPreco = 'OK';
                }else{
                    forEach($selectPrecoBase as $rowPrecoBase){
                        array_push($cdsProdFator, $rowPrecoBase);                                
                    }
                    $stVerifPreco = 'NAO_OK';
                }
                
                if($stVerifPreco == 'OK'){
                    $selectDataEndPed = $this->Ped05700importacaoSolicitacaoComprasService->selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp);
                
                    $selectValidaPreco = $this->Ped05700importacaoSolicitacaoComprasService->selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $selectDataEndPed['DTENTREGA']);
                
                    if($selectValidaPreco != null){
                        $stVerifPreco = 'NAO_OK';
                    }else{
                        $selectVerificaPrecoZerado = $this->Ped05700importacaoSolicitacaoComprasService->selectVerificaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult, $selectDataEndPed['DTENTREGA']);
                        if($selectVerificaPrecoZerado != null){
                            $stVerifPreco = 'PRECO_00';
                             
                            forEach($selectVerificaPrecoZerado as $rowVerificaPrecoZerado){
                                array_push($cdsProdFator, $rowVerificaPrecoZerado);                                
                            }
                        }
                        
                    }
                }

            }else{
                $stVerifPreco = 'SEM_PRECO';
            }
        }
        
        $dados = array(
            'cdsProdFator' => $cdsProdFator,
            'stVerifPreco' => $stVerifPreco
        );
        return $dados;
        
    }
    
    public function Importar($row, $paramImpPed, $parampedido){

        $fator = $this->Ped05700importacaoSolicitacaoComprasService->buscaFator('', 'T');
        $operador = $this->environment->getCdOperador();
        $cdfilial = $this->environment->getCdFilial();
        $cdgrupprod = $this->Ped05700importacaoSolicitacaoComprasService->selectFilial($cdfilial);
        
        
        $retorno = $this->Ped05700importacaoSolicitacaoComprasService->selectExisteSoliCmpPed($row['CDFILLANCA'], $row['CDFILSOLI'], $row['NRSOLICMP']);

        if(!$retorno[0]['QTRETORNO']){
            if($paramImpPed['IDIMPSCDTENTR'] == 'S'){
                $prxPedido = $this->newCode->getCodeByTableName('PEDIDO'.$cdfilial, $this->environment->getNrOrgTrab());
                
                $retornoGrava_Pedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaPedido($cdfilial, $prxPedido, $operador, $row['DTPROGENTR'], $row['CDFILLANCA'], $row['CDFILSOLI'], $row['NRSOLICMP']);
                if($retornoGrava_Pedido['P_CDMENSERRO'] == 'OK'){
                    $itemSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaItemSoli($row['CDFILSOLI'], $row['CDFILLANCA'], $row['NRSOLICMP'], $row['DTPROGENTR'], '');
                    if(!empty($itemSoli)){
                        forEach($itemSoli as $RowItemSoli){
                            $retorno_Grava_ItemPedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaItempedido($cdfilial, $prxPedido, $row['CDFATORPRECO'], $RowItemSoli['CDPRODUTO'], $RowItemSoli['QTSOLIPROD'], $RowItemSoli['DTPROGENTR'], $row['DTPROGENTR']);
                        }
                    }
                    
                    if($parampedido['IDUTRESELOTE'] == 'S'){
                        $this->Ped05700importacaoSolicitacaoComprasService->geraReserva($cdfilial, $prxPedido);
                    }
                    
                    if($parampedido['IDEXIBIMPITPED'] == 'S'){
                        $totalImpost= $this->Ped05700importacaoSolicitacaoComprasService->selectCalcTotImpos($cdfilial, $prxPedido);
                        if($totalImpost != []){
                            forEach($totalImpost as $RowTotalImpost){
                                $ConsImposPedTot = $this->Ped05700importacaoSolicitacaoComprasService->selectConsImposPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO']);
                            
                                if($ConsImposPedTot != []){
                                    $this->Ped05700importacaoSolicitacaoComprasService->insertItemPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO'], $RowTotalImpost['VRIMPOSTOTAL'], $RowTotalImpost['VRBASETOTAL']);
                                }else{
                                    $this->Ped05700importacaoSolicitacaoComprasFactory->updateItemPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO'], $RowTotalImpost['VRIMPOSTOTAL'], $RowTotalImpost['VRBASETOTAL']);
                                }
                            }

                        }
                    }
                    
                }
            }else{
                $itemSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaItemSoli($row['CDFILSOLI'], $row['CDFILLANCA'], $row['NRSOLICMP'], 0, 'T');
                
                if(!empty($itemSoli)){
                    $dtPedido = 0;
                    forEach($itemSoli as $RowItemSoli){
                        if($dtPedido != $RowItemSoli['DTPROGENTR']){
                            $prxPedido = $this->newCode->getCodeByTableName('PEDIDO'.$cdfilial, $this->environment->getNrOrgTrab());
                            $retorno_Grava_Pedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaPedido($cdfilial, $prxPedido, $operador, $cdfilial, $RowItemSoli['DTPROGENTR'], $row['CDFILLANCA'], $row['CDFILSOLI'], $row['NRSOLICMP']);
                        }
                    }
                }
                
            }
        }
        

    }
};