<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Teknisa\PED\Modules\Pedidos\Services\ped00300AprovacaoService;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\Libs\Util\DateUtil;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DTO;

class ped00300AprovacaoController extends TeknisaCrud {

    protected $parameterBag;
    protected $environment;
    protected $entityManager;
    protected $posicaoService;

    public function __construct($crudService, ParameterBag $parameterBag, $environment, $entityManager, $aprovacaoService) {
        parent::__construct($crudService, $parameterBag);
        $this->parameterBag = $parameterBag;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->aprovacaoService = $aprovacaoService;
    }

    public function checkLogin($request, $response) {
        $data = $request->getDataSet();
        $rows = $data->getRows();
        $search = $this->aprovacaoService->checkLogin($rows, $response);
        $dataset = new DataSet('result', $search);
        $response->setDataSets(array($dataset));
    }
    public function pendenciaCheckLogin($request, $response) {
        try {
            $data = $request->getDataSet();
            $rows = $data->getRows();
            $search = $this->aprovacaoService->pendenciaCheckLogin($rows, $response);
            $dataset = new DataSet('result', $search);
            $response->setDataSets(array($dataset));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}